## mpqc3 0.0~git20160216

=== CMakeLists.txt ===
#; -*-CMake-*-

cmake_minimum_required(VERSION 3.0.0)
project (MPQC CXX C Fortran)

# extra cmake files are shipped with MPQC
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake/modules/")

set (MPQC_MAJOR_VERSION 3)
set (MPQC_MINOR_VERSION 0)
set (MPQC_PATCH_VERSION 0)
set(MPQC_BUILDID alpha)
set(MPQC_VERSION "${MPQC_MAJOR_VERSION}.${MPQC_MINOR_VERSION}.${MPQC_PATCH_VERSION}")
if (MPQC_BUILDID)
  set(MPQC_VERSION "${MPQC_VERSION}-${MPQC_BUILDID}")
endif(MPQC_BUILDID)

set(TARGET_ARCH "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")

#####################
# Options
#####################
# boolean
option(MPQC_EXPERT "MPQC Expert mode: disables automatically downloading or building dependencies" OFF)
option(MPQC_NEW_FEATURES "Use new MPQC features (requires C++11)" OFF)
option(MPQC_OPENMP "Use OpenMP" OFF)
# non-boolean
if (NOT DEFINED MPQC_MEMORY_CHECK)
  set(MPQC_MEMORY_CHECK -1) # How to check memory use (see mpqc_config.h for details)
else()
  message("MPQC_MEMORY_CHECK = ${MPQC_MEMORY_CHECK}")
endif()
if (NOT DEFINED MPQC_ASSERT_MODE)
  set(MPQC_ASSERT_MODE -1) # How to implement assertions (see mpqc_config.h for details)
endif()

include(cotire)

include(CTest)
enable_testing()

enable_language (CXX)
if (NOT CMAKE_CXX_COMPILER)
  message(FATAL_ERROR "C++ compiler not found")
endif()

# FORTRAN setup
enable_language (Fortran)
if (NOT CMAKE_Fortran_COMPILER)
   message(FATAL_ERROR "Fortran compiler not found")
endif()
if(INTEGER8) 
  set(F77_INTEGER_WIDTH 8)
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -DINTEGER77='INTEGER*8' ")
else()
  set(F77_INTEGER_WIDTH 4)
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -DINTEGER77='INTEGER*4' ")
endif()
#list(append CMAKE_Fortran_FLAGS "-m64")



##############################
# Build Type Information
##############################
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")

set(CMAKE_SKIP_RPATH FALSE)

set(BUILD_TESTING FALSE CACHE BOOLEAN "BUILD_TESTING")
set(BUILD_TESTING_STATIC FALSE CACHE BOOLEAN "BUILD_TESTING_STATIC")
set(BUILD_TESTING_SHARED FALSE CACHE BOOLEAN "BUILD_TESTING_SHARED")

if (MPQC_OPENMP)
  find_package(OpenMP)
  if (OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
  endif()
endif()

include(TestCXXAcceptsFlag)
include(CheckCXXSourceCompiles)

# Enable CI
if (MPQC_NEW_FEATURES)
  if (NOT DEFINED MPQC_CI)
    set(MPQC_CI FALSE)
  endif()
  if (MPQC_CI)
    add_definitions(-DMPQC_CI)
  endif()
endif()

# Enable Unit Test
if (MPQC_UNITTEST)
  if (NOT MPQC_NEW_FEATURES) 
    message(FATAL_ERROR "Unit testing requires MPQC_NEW_FEATURES")
  endif()
  if (BOOST)
    message(FATAL_ERROR "Must have MPQC build Boost for unit testing")
  endif()
  add_definitions(-DMPQC_UNITTEST)
endif()
    

if (MPQC_NEW_FEATURES)
  add_definitions(-DMPQC_NEW_FEATURES)
  
  # "some" C++11 features are required, check if we need a flag to turn on the support in the compiler
  # N.B. even though clang++ assumes c++11, it still needs the flag for some features (e.g. static_assert)
  CHECK_CXX_ACCEPTS_FLAG("-std=c++11" CXX_FLAG_CXX11)
  if(CXX_FLAG_CXX11)
    set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
    message(STATUS "C++11 flag: -std=c++11")
  endif()
  if (NOT CXX_FLAG_CXX11)
    CHECK_CXX_ACCEPTS_FLAG("-std=c++0x" CXX_FLAG_CXX0X)
  endif()
  if (CXX_FLAG_CXX0X)
    set(CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}")
    message(STATUS "C++11 flag: -std=c++0x")
  endif()
  
endif()

# C++11 features
CHECK_CXX_SOURCE_COMPILES("
  int main() {
  auto c = 1;
  }"
  HAVE_CXX_AUTO)  
if (MPQC_NEW_FEATURES AND NOT HAVE_CXX_AUTO)
  message(FATAL_ERROR "MPQC_NEW_FEATURES requires support for C++11 auto")
endif()

# std::array
CHECK_CXX_SOURCE_COMPILES("
    #include <array>
    int main(void)
    {
      std::array<int,2> array;
    }"
    HAVE_STD_ARRAY)

CHECK_CXX_SOURCE_COMPILES("
  int main() {
  void *restrict ptr;
  }" HAVE_CXX_RESTRICT)

CHECK_CXX_SOURCE_COMPILES("
  int main() {
  void *__restrict__ ptr;
  }" HAVE_CXX___RESTRICT__)



option(USE_STATIC_LIBS "use static libraries" OFF)
if(USE_STATIC_LIBS)
  set(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
ENDIF()

include(CheckIncludeFiles)

find_package(Threads)
if (Threads_FOUND)
  set(Threads_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
  check_include_files(pthread.h HAVE_PTHREAD)
endif()



include(CheckTypeSize)
check_type_size(int64_t C_TYPE_INT64_T)
check_type_size(int32_t C_TYPE_INT32_T)
check_type_size(long C_TYPE_LONG)
check_type_size(int C_TYPE_INT)

check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(dlfcn.h HAVE_DLFCN_H)
check_include_files(sys/time.h HAVE_SYS_TIME_H)
check_include_files(sys/times.h HAVE_SYS_TIMES_H)
check_include_files(sys/resource.h HAVE_SYS_RESOURCE_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(pwd.h HAVE_PWD_H)
check_include_files(time.h HAVE_TIME_H)
check_include_files(libunwind.h HAVE_LIBUNWIND_H)
include(CheckIncludeFileCXX)
CHECK_INCLUDE_FILE_CXX(cxxabi.h HAVE_CXXABI_H)
check_include_files(execinfo.h HAVE_EXECINFO_H)

include(CheckFunctionExists)

CHECK_FUNCTION_EXISTS (gethostname       HAVE_GETHOSTNAME)
CHECK_FUNCTION_EXISTS (getpwuid          HAVE_GETPWUID)
CHECK_FUNCTION_EXISTS (geteuid           HAVE_GETEUID)
CHECK_FUNCTION_EXISTS (getrusage         HAVE_GETRUSAGE)
CHECK_FUNCTION_EXISTS (lstat             HAVE_LSTAT)
CHECK_FUNCTION_EXISTS (time              HAVE_TIME)
CHECK_FUNCTION_EXISTS (ctime             HAVE_CTIME)
CHECK_FUNCTION_EXISTS (posix_spawn       HAVE_POSIX_SPAWN)
if (HAVE_CXXABI_H)
  CHECK_CXX_SOURCE_COMPILES("
    #include <cxxabi.h>
    int main(int argc, char* argv[]) {
      char* result = abi::__cxa_demangle(\"\", 0, 0, 0);
      return 0;
    }" HAVE_CXA_DEMANGLE)
  if (HAVE_CXA_DEMANGLE)
    message("-- Looking for abi::__cxa_demangle - found")
  else()
    message("-- Looking for abi::__cxa_demangle - not found")
  endif()
endif(HAVE_CXXABI_H)
if (HAVE_LIBUNWIND_H)
  CHECK_FUNCTION_EXISTS (unw_init_local          HAVE_LIBUNWIND)
endif(HAVE_LIBUNWIND_H)
if (HAVE_EXECINFO_H)
  CHECK_FUNCTION_EXISTS (backtrace               HAVE_BACKTRACE_FN)
  CHECK_FUNCTION_EXISTS (backtrace_symbols       HAVE_BACKTRACE_SYMBOLS_FN)
  if (HAVE_BACKTRACE_FN AND HAVE_BACKTRACE_SYMBOLS_FN)
    set (HAVE_BACKTRACE)
  endif()
else (HAVE_EXECINFO_H)
  #find_package(ExecInfo)
endif (HAVE_EXECINFO_H)


include(FortranCInterface)
FortranCInterface_VERIFY(CXX)

set(FORTRAN_FUNCTIONS
  PDSTEQR
  DCOPY
  DNRM2
  DSCAL
  DGEMM
  DGEMV
  DAXPY
  DDOT
  DSPMV
  DGESVD
  DSPSVX
  DSYEVD
  DSPTRF
  DPPTRF
  DSPTRI
  DPPTRI
  DLANSP
  DSPCON
  DPPCON
  DLAMCH
  DLACPY
  DSPTRS
  DPPTRS
  DSPRFS
  DPPRFS
  DSYGV
  DGEQRF
  DGETRF
  DGETRS
  DORGQR
  DPOTF2
  DTRTRS
  )

set(fortran_headers 
lib/math/optimize/f77sym.h
lib/math/optimize/levmar/f77sym.h
lib/math/scmat/f77sym.h
)

foreach(header ${fortran_headers})
  FortranCInterface_HEADER(
    ${PROJECT_BINARY_DIR}/src/${header}
    MACRO_NAMESPACE "FC_"
    SYMBOL_NAMESPACE "F77_"
    SYMBOLS ${FORTRAN_FUNCTIONS}
    )
endforeach()

include(GNUInstallDirs)           

set(SRC_MPQC_DATA_PATH ${PROJECT_SOURCE_DIR}/lib)
set(MPQCDATAPATH ${CMAKE_INSTALL_FULL_DATAROOTDIR}/mpqc/${MPQC_VERSION})
set(INSTALLED_MPQC_DATA_PATH ${CMAKE_INSTALL_FULL_DATAROOTDIR}/mpqc/${MPQC_VERSION})

INSTALL(FILES ./lib/atominfo.kv DESTINATION ${MPQCDATAPATH})
INSTALL(DIRECTORY ./lib/basis DESTINATION ${MPQCDATAPATH})

include_directories("${PROJECT_BINARY_DIR}/src/lib")
include_directories("${PROJECT_SOURCE_DIR}/src/lib")
include_directories("${PROJECT_SOURCE_DIR}/include") # flex/lexer

# external dependencies
include(external/External)

CONFIGURE_FILE(
  ${PROJECT_SOURCE_DIR}/src/lib/mpqc_config.h.in
  ${PROJECT_BINARY_DIR}/src/lib/mpqc_config.h
)
add_definitions(-DHAVE_CONFIG_H)

CONFIGURE_FILE(
  ${PROJECT_SOURCE_DIR}/bin/mpqcrun.in
  ${PROJECT_BINARY_DIR}/bin/mpqcrun
  @ONLY
)

# libraries
set(LINK_LIBRARIES)
list(APPEND LINK_LIBRARIES ${LIBRYSQ_LIBRARY})
list(APPEND LINK_LIBRARIES ${LIBINT2_LIBRARY})
list(APPEND LINK_LIBRARIES ${PSI3_LIBRARIES})
list(APPEND LINK_LIBRARIES ${TILEDARRAY_LIBRARIES})
list(APPEND LINK_LIBRARIES ${OPENBABEL2_LIBRARIES})
list(APPEND LINK_LIBRARIES ${Boost_LIBRARIES})
if (MPQC_UNITTEST)
  list(APPEND LINK_LIBRARIES ${Boost_UNITTEST_LIBRARIES})
endif()
list(APPEND LINK_LIBRARIES ${LAPACK_LIBRARIES})
list(APPEND LINK_LIBRARIES ${BLAS_LIBRARIES})
list(APPEND LINK_LIBRARIES ${PYTHON_LIBRARIES})
list(APPEND LINK_LIBRARIES ${HDF5_LIBRARIES})
list(APPEND LINK_LIBRARIES ${ARMCI_LIBRARIES})
list(APPEND LINK_LIBRARIES ${MPI_LIBRARIES})
list(APPEND LINK_LIBRARIES ${PAPI_LIBRARIES})
list(APPEND LINK_LIBRARIES ${Threads_LIBRARIES})
list(APPEND LINK_LIBRARIES ${LIBRARIES})
list(APPEND LINK_LIBRARIES ${CMAKE_DL_LIBS})

########################################################
# determine whether certain features lack preprequisites
########################################################
# R12
if (HAVE_LIBINT2)
  set(MPQC_R12 TRUE)
  add_definitions(-DMPQC_R12)
else()
  message("** R12 methods require Libint2.  R12 methods are disabled")
endif()

# propagate some variables into Makefiles
if (MPQC_NEW_FEATURES)
  set(MAKE_ASSUME_NEW_FEATURES yes)
endif()

if (MPQC_CI)
  set(MAKE_ASSUME_CI yes)
endif()

if (MPQC_R12)
  set(MAKE_ASSUME_R12 yes)
endif()

if (HAVE_PSI3)
  set(MAKE_ASSUME_PSI yes)
endif()

if (HAVE_LIBINT2)
  if (LIBINT_SUPPORTS_G12_T1G12_INTEGRALS)
    set(MAKE_ASSUME_LIBINT2_SUPPORTS_T1G12 yes)
  endif()
endif()

# sources
add_subdirectory(src)
add_subdirectory(doc EXCLUDE_FROM_ALL) # will not build docs by default

# checking/testing
add_subdirectory(test)


# Export include dirs, library list

set(MPQC_CONFIG_LIBRARIES "")

# Fortran libraries
foreach (_lib ${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES})
  set(_libpath _libpath-NOTFOUND)
  find_library(_libpath ${_lib} PATHS ${CMAKE_Fortran_IMPLICIT_LINK_DIRECTORIES})
  if (_libpath)
    list(APPEND LINK_LIBRARIES ${_libpath})
  else()
    list(APPEND LINK_LIBRARIES ${_lib})
  endif()
endforeach()

# transform library list into compiler args
include(ConvertLibrariesListToCompilerArgs)
convert_libs_to_compargs(MPQC_CONFIG_LIBRARIES "${LINK_LIBRARIES}")
#message(STATUS "MPQC_CONFIG_LIBRARIES = ${MPQC_CONFIG_LIBRARIES}")

# include dirs
get_directory_property(MPQC_INCLUDE_DIRECTORIES DIRECTORY src/bin/mpqc INCLUDE_DIRECTORIES)
# remove internal source dirs
list(REMOVE_ITEM
  MPQC_INCLUDE_DIRECTORIES
  ${PROJECT_BINARY_DIR}/src/lib
  ${PROJECT_SOURCE_DIR}/src/lib
  ${PROJECT_SOURCE_DIR}/include
) 

set(MPQC_CPP_FLAGS "${CMAKE_CPP_FLAGS}")
foreach (_dir ${MPQC_INCLUDE_DIRECTORIES})
  set(MPQC_CPP_FLAGS "${MPQC_CPP_FLAGS} -I${_dir}")
endforeach()
# MPQC includes
set(MPQC_CPP_FLAGS "-I${CMAKE_INSTALL_PREFIX}/include/ ${MPQC_CPP_FLAGS}")
set(MPQC_CPP_FLAGS "-I${CMAKE_INSTALL_PREFIX}/include/mpqc ${MPQC_CPP_FLAGS}")
#message(STATUS "MPQC_CPP_FLAGS = ${MPQC_CPP_FLAGS}")

CONFIGURE_FILE(
  ${PROJECT_SOURCE_DIR}/bin/mpqc-config.in
  ${PROJECT_BINARY_DIR}/bin/mpqc-config
  @ONLY
)

# GLOB all the files so they show up in qt_creator
if(USING_QT_CREATOR_AS_IDE)
  file(GLOB_RECURSE QT_CREATOR_SRC 
    "*.h" 
    "*.hpp" 
    "*.cpp" 
    "*.c" 
    "*.txt" 
    "*.in" 
    "*.cc"
    "*.f"
    "TODO"
  )

  add_library(qt_creator_get_sources EXCLUDE_FROM_ALL ${QT_CREATOR_SRC})

  set_target_properties(qt_creator_get_sources PROPERTIES LINKER_LANGUAGE CXX)

endif(USING_QT_CREATOR_AS_IDE)


install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/bin/mpqc-config DESTINATION bin)

=== cmake/Makefile ===
CMAKE := cmake-3.4.3
URL := https://cmake.org/files/v3.4/$(CMAKE).tar.gz
PREFIX := $(PWD)

all: cmake

wget := $(shell wget 2>/dev/null)
curl := $(shell curl 2>/dev/null)

ifneq  ($(wget), )
download := wget $(URL) -O $(CMAKE).tar.gz
else
download := curl $(URL) -o $(CMAKE).tar.gz
endif


$(CMAKE).tar.gz:
	$(download)

.PHONY: cmake
cmake: $(CMAKE).tar.gz
	tar -xzf $(CMAKE).tar.gz
	cd ./$(CMAKE)
	cd $(CMAKE) && ./configure --prefix=$(PREFIX) # --system-curl
	cd $(CMAKE) && make install

=== doc/CMakeLists.txt ===
set (CMAKE_DOCINSTALL_PATH ${CMAKE_INSTALL_PREFIX}/share/doc/mpqc-${MPQC_VERSION})
INSTALL(DIRECTORY ./devsamp/hf DESTINATION ${CMAKE_DOCINSTALL_PATH}/examples)
INSTALL(DIRECTORY ./devsamp/mp2 DESTINATION ${CMAKE_DOCINSTALL_PATH}/examples)
INSTALL(DIRECTORY ./devsamp/aoints DESTINATION ${CMAKE_DOCINSTALL_PATH}/examples)

#-- Add an Option to toggle the generation of the API documentation

find_package(Doxygen)
if(DOXYGEN_FOUND)
  configure_file(Doxyfile.in Doxyfile @ONLY IMMEDIATE)
  
  add_custom_command( OUTPUT ${PROJECT_BINARY_DIR}/doc/html/index.html
                      COMMAND ${DOXYGEN_EXECUTABLE} ${PROJECT_BINARY_DIR}/doc/Doxyfile
                      MAIN_DEPENDENCY ${PROJECT_BINARY_DIR}/doc/Doxyfile ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
                      DEPENDS
                        ${CMAKE_CURRENT_SOURCE_DIR}/DoxygenLayout.xml
                        ${CMAKE_CURRENT_SOURCE_DIR}/compile.dox
                        ${CMAKE_CURRENT_SOURCE_DIR}/develop.dox
                        ${CMAKE_CURRENT_SOURCE_DIR}/footer.html
                        ${CMAKE_CURRENT_SOURCE_DIR}/overview.dox
                        ${CMAKE_CURRENT_SOURCE_DIR}/sf_footer.html
                        ${CMAKE_CURRENT_SOURCE_DIR}/srctree.dox
                        ${CMAKE_CURRENT_SOURCE_DIR}/modules.dox
                        ${CMAKE_CURRENT_SOURCE_DIR}/top.dox
                        ${CMAKE_SOURCE_DIR}/bin/mpqcrun.dox
                        ${CMAKE_SOURCE_DIR}/bin/mpqcrunning.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/molrender/molrender.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/mpqc/mpqc.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/mpqc/mpqccomp.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/mpqc/mpqcinp.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/mpqc/mpqclic.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/mpqc/mpqcoo.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/mpqc/mpqcover.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/mpqc/mpqcsimp.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/mpqc/mpqcval.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/mpqc/mpqcwar.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/scls/scls.dox
                        ${CMAKE_SOURCE_DIR}/src/bin/scpr/scpr.dox
                        ${CMAKE_SOURCE_DIR}/src/lib/chemistry/qc/psi/mpqcpsi.dox
                        ${CMAKE_SOURCE_DIR}/src/lib/math/scmat/scmat.dox
                        ${CMAKE_SOURCE_DIR}/src/lib/math/symmetry/symmetry.dox
                        ${CMAKE_SOURCE_DIR}/src/lib/util/class/class.dox
                        ${CMAKE_SOURCE_DIR}/src/lib/util/group/group.dox
                        ${CMAKE_SOURCE_DIR}/src/lib/util/keyval/keyval.dox
                        ${CMAKE_SOURCE_DIR}/src/lib/util/ref/ref.dox
                        ${CMAKE_SOURCE_DIR}/src/lib/util/state/state.dox
                      IMPLICIT_DEPENDS
                        CXX ${CMAKE_SOURCE_DIR}/src/bin/mpqc/mpqc.cc
                        CXX ${CMAKE_SOURCE_DIR}/src/bin/pt2r12/pt2r12.cc
                      COMMENT "Generating MPQC API documentation with Doxygen")
  
  INSTALL( DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION ${CMAKE_DOCINSTALL_PATH})

  add_custom_target (html
    DEPENDS ${PROJECT_BINARY_DIR}/doc/html/index.html)

endif()

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

# skeleton for CTest - implement in future
# #add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
# enable_testing()

# file(GLOB REF RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ref/*.in)

# foreach(input ${REF})
#   add_test(${input} ../mpqc.py "-X ${CMAKE_CURRENT_SOURCE_DIR}/../src/bin/mpqc/mpqc" ${input})
# endforeach()

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/check.mk.in
  ${CMAKE_CURRENT_BINARY_DIR}/check.mk
  @ONLY
)

# make.sh runs tests for every integral factory
set(MPQC_INTEGRAL_FACTORY_LIST "intv3")
if (HAVE_LIBINT1)
  list(APPEND MPQC_INTEGRAL_FACTORY_LIST "cints")
endif (HAVE_LIBINT1)
if (HAVE_LIBINT2)
  list(APPEND MPQC_INTEGRAL_FACTORY_LIST "libint2")
endif (HAVE_LIBINT2)
string(REPLACE ";" " " MPQC_INTEGRAL_FACTORY_STRLIST "${MPQC_INTEGRAL_FACTORY_LIST}")
message (STATUS "MPQC_INTEGRAL_FACTORY_STRLIST=${MPQC_INTEGRAL_FACTORY_STRLIST}")
CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/make.sh.in
  ${CMAKE_CURRENT_BINARY_DIR}/make.sh
  @ONLY
)

add_custom_target(
  check0
  COMMAND ./make.sh check0
)

add_custom_target(
  check1
  COMMAND ./make.sh check1
)

add_custom_target(
  check2
  COMMAND ./make.sh check2
)

add_custom_target(
  check
  DEPENDS check0
)

# checking
add_custom_target(
  check_clean
  COMMAND make -f check.mk check_clean
)

=== src/lib/CMakeLists.txt ===
add_subdirectory(mpqc)
add_subdirectory(util)
add_subdirectory(math)
add_subdirectory(chemistry)
add_subdirectory(extern)

# library headers
file(GLOB_RECURSE headers RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} chemistry/*.h math/*.h util/*h)
foreach (_file ${headers})
  get_filename_component(_path ${_file} PATH)
  #message(STATUS "gonna installl ${_file} in include/mpqc/${_path}" )
  install(FILES ${_file} DESTINATION include/mpqc/${_path})
endforeach()
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mpqc_config.h DESTINATION include/mpqc)

=== doc/devsamp/aoints/Makefile ===
# Change this to the (absolute) path to your installed mpqc-config script, if needed
MPQCCONFIG = ../../../../../bin/mpqc-config
CXX := $(shell $(MPQCCONFIG) --cxx)
CXXFLAGS := $(shell $(MPQCCONFIG) --cxxflags)
CC := $(shell $(MPQCCONFIG) --cc)
CCFLAGS := $(shell $(MPQCCONFIG) --cflags)
F77 := $(shell $(MPQCCONFIG) --f77)
F90 := $(F77)
FFLAGS := $(shell $(MPQCCONFIG) --f77flags)
F90FLAGS := $(FFLAGS)
CPPFLAGS := $(shell $(MPQCCONFIG) --cppflags)
LIBS := $(shell $(MPQCCONFIG) --libs)
LIBDIR  := $(shell $(MPQCCONFIG) --libdir)
LDFLAGS := $(shell $(MPQCCONFIG) --ldflags)

aoints: aoints.o
	$(CXX) $(CXXFLAGS) -o $@ $^ -L$(LIBDIR) $(LDFLAGS) $(LIBS)

clean:
	-rm -f aoints aoints.o

=== doc/devsamp/hf/Makefile ===
# Change this to the (absolute) path to your installed mpqc-config script, if needed
MPQCCONFIG = ../../../../../bin/mpqc-config
CXX := $(shell $(MPQCCONFIG) --cxx)
CXXFLAGS := $(shell $(MPQCCONFIG) --cxxflags)
CC := $(shell $(MPQCCONFIG) --cc)
CCFLAGS := $(shell $(MPQCCONFIG) --cflags)
F77 := $(shell $(MPQCCONFIG) --f77)
F90 := $(F77)
FFLAGS := $(shell $(MPQCCONFIG) --f77flags)
F90FLAGS := $(FFLAGS)
CPPFLAGS := $(shell $(MPQCCONFIG) --cppflags)
LIBS := $(shell $(MPQCCONFIG) --libs)
LIBDIR  := $(shell $(MPQCCONFIG) --libdir)
LDFLAGS := $(shell $(MPQCCONFIG) --ldflags)

TARGET = hf

$(TARGET): $(TARGET).o
	$(CXX) $(CXXFLAGS) -o $@ $^ -L$(LIBDIR) $(LDFLAGS) $(LIBS)

clean:
	-rm -f $(TARGET) $(TARGET).o

=== doc/devsamp/mp2/Makefile ===
# Change this to the (absolute) path to your installed mpqc-config script, if needed
MPQCCONFIG = ../../../../../bin/mpqc-config
CXX := $(shell $(MPQCCONFIG) --cxx)
CXXFLAGS := $(shell $(MPQCCONFIG) --cxxflags)
CC := $(shell $(MPQCCONFIG) --cc)
CCFLAGS := $(shell $(MPQCCONFIG) --cflags)
F77 := $(shell $(MPQCCONFIG) --f77)
F90 := $(F77)
FFLAGS := $(shell $(MPQCCONFIG) --f77flags)
F90FLAGS := $(FFLAGS)
CPPFLAGS := $(shell $(MPQCCONFIG) --cppflags)
LIBS := $(shell $(MPQCCONFIG) --libs)
LIBDIR  := $(shell $(MPQCCONFIG) --libdir)
LDFLAGS := $(shell $(MPQCCONFIG) --ldflags)

TARGET = mp2

$(TARGET): $(TARGET).o
	$(CXX) $(CXXFLAGS) -o $@ $^ -L$(LIBDIR) $(LDFLAGS) -lmpqcmain $(LIBS)

clean:
	-rm -f $(TARGET) $(TARGET).o

=== src/bin/mpqc/CMakeLists.txt ===
set(executable mpqc)

add_library(
  mpqcmain
  mpqc.cc
)

add_library(
  mpqcinit
  mpqcin.cc
  mpqcinit.cc
  parse.cc
  scan.cc  
)

add_executable(
  ${executable}
  mpqc.cc
)

target_link_libraries(
  mpqcmain
  mpqcinit
)

target_link_libraries(
  mpqcinit
  chemistry
  util
  extern_moinfo
)

# N.B. mpqcinit alone has almost no dependencies
# library dependencies should be tied to chemistry and util
target_link_libraries(
  ${executable}
  mpqcinit
  ${LINK_LIBRARIES}
)

set_target_properties(${executable} PROPERTIES COTIRE_UNITY_LINK_LIBRARIES_INIT "COPY")
cotire(${executable})

install(TARGETS ${executable} RUNTIME DESTINATION bin)

set(headers mpqcinit.h mpqcin.h)
foreach (_file ${headers})
  #message(STATUS "gonna install ${_file} in include/mpqc" )
  install(FILES ${_file} DESTINATION include/mpqc)
endforeach()

install(TARGETS mpqcinit DESTINATION lib)
install(TARGETS mpqcmain DESTINATION lib)

=== src/bin/pt2r12/CMakeLists.txt ===

if (GAMESS)

  set(CMAKE_CXX_FLAGS "-DPT2R12GAMESS ${CMAKE_CXX_FLAGS}")
  
endif()

set(executable pt2r12)
add_executable(
    ${executable}
    pt2r12.cc
)

target_link_libraries(
    ${executable}
    mpqcinit
    chemistry
    math
    util
    extern_moinfo
    ${LINK_LIBRARIES}
)

install(TARGETS ${executable} DESTINATION bin)

  #set(headers extern_pt2r12.h moinfo.h molden_moinfo.h)
  #foreach (_file ${headers})
  #  install(FILES ${_file} DESTINATION include/mpqc/pt2r12)
  #endforeach()

=== src/lib/chemistry/CMakeLists.txt ===
include(AddLibrary)

SUBDIRLIST(Subdirs CMAKE_CURRENT_SOURCE_DIR)

FOREACH(subdir ${Subdirs})
    ADD_SUBDIRECTORY(${subdir})
ENDFOREACH()

set(chemobjects
  molecule
  qc
  solvent
)

add_mpqc_library(chemistry ${chemobjects})
add_dependencies(math util)

target_link_libraries(chemistry math util)
target_link_libraries(chemistry ${OPENBABEL2_LIBRARIES})
target_link_libraries(chemistry ${LIBINT2_LIBRARY})
target_link_libraries(chemistry ${PSI3_LIBRARIES})
target_link_libraries(chemistry ${Boost_LIBRARIES})
target_link_libraries(chemistry ${PYTHON_LIBRARIES})
target_link_libraries(chemistry ${HDF5_LIBRARIES})
target_link_libraries(chemistry ${ARMCI_LIBRARIES})
target_link_libraries(chemistry ${MPI_LIBRARIES})
target_link_libraries(chemistry ${TILEDARRAY_LIBRARIES})

install(TARGETS chemistry DESTINATION lib)

=== src/lib/extern/CMakeLists.txt ===

add_subdirectory(qc)
add_subdirectory(moinfo)

if (HAVE_PYTHON AND HAVE_PYTHON_NUMPY)
  add_subdirectory(python)
endif()

=== debian/changelog ===
mpqc3 (0.0~git20160216-6) unstable; urgency=medium

  * debian/control (Build-Depends): Bump required libint2-dev version to
    2.1.0-3.
  * debian/patches/cmake_libint_check.patch: Removed, no longer needed.

 -- Michael Banck <mbanck@debian.org>  Sat, 08 Oct 2016 15:17:41 +0200

mpqc3 (0.0~git20160216-5) unstable; urgency=medium

  * debian/patches/cmake_libint_check.patch: New patch, removes one check from
    the Libint detection which is no longer applicable (Closes: #839361).

 -- Michael Banck <mbanc@debian.org>  Sun, 02 Oct 2016 19:36:10 +0200

mpqc3 (0.0~git20160216-4) unstable; urgency=medium

  * debian/patches/remove_debug_output.patch: New patch, removes overly verbose
    output.
  * debian/control (mpqc3/Description): Mention that CASSCF-F12 and MRCI-F12
    are density-fitted as well.
  * debian/patches/continue_testsuite_on_failures.patch: New patch, continues
    running the test suite for other integral types on failures, taken from
    upstream revisions 77002df9 and 81a8a7ca.
  * debian/rules (override_dh_auto_configure): Print out CMakeError.log on
    failure.

 -- Michael Banck <mbanck@debian.org>  Sat, 01 Oct 2016 21:34:48 +0200

mpqc3 (0.0~git20160216-3) unstable; urgency=medium

  * debian/patches/check_for_psio_purge.patch: Updated to properly cleanup
    after psi3 computations.
  * debian/patches/psi3_default_directory.patch: New patch, runs psiclean
    executable from correct directory.
  * debian/control (mpqc3/Description): Add MRCI-F12 to capabilities.

 -- Michael Banck <mbanck@debian.org>  Fri, 19 Feb 2016 08:27:43 +0100

mpqc3 (0.0~git20160216-2) unstable; urgency=medium

  * debian/control (Build-Depends): Added libpsi3-dev and psi3.
  * debian/control (mpqc3/Depends): Added psi3.
  * debian/control (mpqc3/Description): Add CASSCF-F12 to capabilities.
  * debian/patches/check_for_psio_purge.patch: New patch, avoids post
    psicode-3.4.0 features.
  * debian/control (Build-Depends): Added libopenbabel-dev.

 -- Michael Banck <mbanck@debian.org>  Fri, 19 Feb 2016 00:40:43 +0100

mpqc3 (0.0~git20160216-1) unstable; urgency=medium

  * New upstream development snapshot.

 -- Michael Banck <mbanck@debian.org>  Wed, 17 Feb 2016 00:08:44 +0100

mpqc3 (0.0~git20160214-1) unstable; urgency=medium

  * New upstream development snapshot.
    + fixes a build failure on 32bit architectures; Closes: #814130.
  * debian/control (Build-Depends): Added libint2-dev.
  * debian/patches/fix_cmake_configure_error.patch: Refreshed.

 -- Michael Banck <mbanck@debian.org>  Sun, 14 Feb 2016 14:58:16 +0100

mpqc3 (0.0~git20150911-1) unstable; urgency=medium

  * Initial release.

 -- Michael Banck <mbanck@debian.org>  Sat, 06 Feb 2016 22:09:41 +0100

=== debian/control ===
Source: mpqc3
Priority: optional
Section: science
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake (>= 2.8.11),
               debhelper (>> 8),
               gfortran,
               libblas-dev,
               libboost-dev,
               libeigen3-dev,
               liblapack-dev,
               libint2-dev (>= 2.1.0-3),
               libopenbabel-dev,
               libpapi-dev,
               libpsi3-dev,
               mpi-default-bin,
               mpi-default-dev,
               psi3 
Standards-Version: 3.9.6
Homepage: http://www.mpqc.org
Vcs-Browser: http://svn.debian.org/wsvn/debichem/unstable/mpqc3/
Vcs-Svn: svn://svn.debian.org/svn/debichem/unstable/mpqc3/

Package: mpqc3
Architecture: any
Depends: mpi-default-bin,
         mpqc3-data, 
         psi3,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Massively Parallel Quantum Chemistry Program
 MPQC3 is an ab-inito quantum chemistry program.  It is especially designed to
 compute molecules in an explicitly-correlated fashion.
 .
 It can compute energies and gradients for the following methods:
  * Hartree-Fock (HF)
  * Density Functional Theory (DFT)
  * Second-order Moeller-Plesset pertubation theory (MP2)
 .
 Additionally, it can compute energies for the following methods:
  * Local MP2 (LMP2)
  * Explicitly-correlated density-fitted MP2 (DF-MP2-F12)
  * Explicitly-correlated density-fitted coupled-cluster singles doubles
    (DF-CCSD-F12)
  * Explicitly-correlated density-fitted coupled-cluster singles doubles with
    perturbative triples (DF-CCSD(T)-F12)
  * Explicitly-correlated density-fitted complete active space SCF
    (DF-CASSCF-F12)
  * Explicitly-correlated density-fitted multi-reference configuration
    interaction (DF-MRCI-F12)
 .
 It also includes an internal coordinate geometry optimizer.

Package: mpqc3-data
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Massively Parallel Quantum Chemistry Program (data files)
 MPQC3 is an ab-inito quantum chemistry program.  It is especially designed to
 compute molecules in an explicitly-correlated fashion.
 .
 This package contains the basis sets.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export CXXFLAGS=-g -O2 -std=c++11
export OMPI_MCA_orte_rsh_agent=/bin/false

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DMPI_C_COMPILER=mpicc || cat */CMakeFiles/CMakeError.log

override_dh_auto_install:
	dh_auto_install
	mv $(CURDIR)/debian/tmp/usr/bin/mpqc \
	   $(CURDIR)/debian/tmp/usr/bin/mpqc3

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	-(cd obj-*/test; make check0)
endif
